package com.hywa.banktest.config;

import javax.annotation.PostConstruct;
import javax.sql.DataSource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.hywa.banktest.model._MappingKit;
import com.jfinal.kit.PathKit;
import com.jfinal.plugin.activerecord.ActiveRecordPlugin;
import com.jfinal.template.source.ClassPathSourceFactory;


@Component
public class ActiveRecord {

	@Autowired
	DataSource dataSource;
	
	@PostConstruct
	public void init(){
		ActiveRecordPlugin arp = new ActiveRecordPlugin(dataSource);
		arp.stop();
		_MappingKit.mapping(arp);
		//arp.setBaseSqlTemplatePath(PathKit.getRootClassPath() + "/sql");
		arp.getEngine().setSourceFactory(new ClassPathSourceFactory());
		arp.addSqlTemplate("/sql/all.sql");
		arp.setShowSql(true);
		arp.start();
	}
	
}
