package com.hywa.banktest.service;

import java.util.List;
import java.util.Map;

import com.hywa.banktest.bankframework.pack.TransVo;
import com.hywa.banktest.model.OrderInfo;

public interface OrderInfoService extends BaseService<OrderInfo> {

	/**
	 * 得到需要清算的订单信息
	 * @param queryModel
	 * @return
	 */
	List<OrderInfo> getTransOrderInfo(OrderInfo queryModel);

	/**
	 * 查询可以打款的订单（按农户打款）
	 * @param map
	 * @return
	 */
	List<Map> queryTransFarmerOrderInfo(Map map);

	/**
	 * 通过farmerId更新订单信息
	 * @param params
	 * @return
	 */
	int updateOrderInfoByFarmer(Map params);


	/**
	 * 查询有订单记录农户信息，为验证测试打款使用
	 * @return
	 */
	List<Map> queryTransFarmerForTest();

	/**
	 * 处理清款记录明细
	 * @param recordId
	 * @param companyType
	 * @return
	 */
	int  dealClearingRecordByRid(String recordId,String companyType);

	/**
	 * 通过清款明细id，更新订单详情记录
	 * @param transVoList
	 * @return
	 */
	int updateOrderInfoByClearingId(List<TransVo> transVoList);

	/**
	 * 银行打款请求失败后，对订单详情的处理
	 * @param transVoList
	 * @return
	 */
	int updateAllClearingDetailOrderInfo(List<TransVo> transVoList);
	/**
	* @MethodName updateNoOrderClearing
	* @Param [transVoList]
	* @Return int
	* @Author qiubo
	* @Date 2020/5/19
	* @Description 修改订单失败以后将其修改为没有订单单款状太
	*/
	public int updateNoOrderClearing(List<TransVo> transVoList);





	
}
