package com.hywa.banktest.service.impl;

import com.hywa.banktest.bankframework.pack.TransVo;
import com.hywa.banktest.dao.PaymentRecordMapper;
import com.hywa.banktest.entity.PaymentRecord;
import com.hywa.banktest.service.PaymentRecordService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("paymentRecordService")
public class PaymentRecordServiceImpl implements PaymentRecordService {

    private static final String TRANS_SUCCESS_CODE="0000";

    @Resource
    private PaymentRecordMapper paymentRecordMapper;

    @Override
    public int deleteById(Integer id) {
        return paymentRecordMapper.deleteByPrimaryKey(id);
    }

    @Override
    public int insertByModel(PaymentRecord record) {
        return paymentRecordMapper.insert(record);
    }

    @Override
    public int insertSelectiveModel(PaymentRecord record) {
        return paymentRecordMapper.insertSelective(record);
    }

    @Override
    public PaymentRecord queryById(Integer id) {
        return paymentRecordMapper.selectByPrimaryKey(id);
    }

    @Override
    public int updateByIdSelective(PaymentRecord record) {
        return paymentRecordMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int updateById(PaymentRecord record) {
        return paymentRecordMapper.updateByPrimaryKey(record);
    }

    @Override
    public List<Map> queryListByParentId(Integer parentId) {
        //TODO empty implements
        return null;
    }

    @Override
    public List<PaymentRecord> queryModelByName(String name) {
        //TODO empty implements
        return null;
    }

    @Override
    public int batchSavePaymentRecordService(List<TransVo> list) {
        List<PaymentRecord> resultList = new ArrayList<>();
        if(null!=list && list.size()>0){
            for (TransVo tran : list){
                PaymentRecord record = new PaymentRecord();
                record.setPaymentStatus(tran.getBankDealState().equals(TRANS_SUCCESS_CODE)?1:0);
                record.setPaymentMsg(tran.getBankDealMsg());
                record.setTargetFarmerId(tran.getId());
                record.setTargetFarmerName(tran.getFarmerName());
                record.setTargetFarmerCardId(tran.getBankAccount());
                record.setPaymentTime(new Date());
                resultList.add(record);
            }
          return paymentRecordMapper.batchInsertModel(resultList);
        }
        return 0;
    }
}
